'Naughts and Crosses  (C) 1999 William Denniss, Final Version
'PLEASE NOTE:  The author of Naughts and Crosses (William Denniss) has released its source code.
'You may use this for what ever you want, so long as the original author is recognised.  It is a small thing to ask, but an important issue, as the author has spent a lot of time designing this program.
'Thank you in advance for your cooperation

DECLARE SUB box (xi AS INTEGER, yi AS INTEGER, xf AS INTEGER, yf AS INTEGER, boxwidth AS INTEGER, boardercolour AS INTEGER, fillcolour AS INTEGER)
DECLARE FUNCTION coltrans$ (colour AS INTEGER)
DECLARE SUB eraseall ()
DECLARE FUNCTION symbols$ (ky AS STRING)
DECLARE FUNCTION nameinput$ (initplace AS INTEGER, row AS INTEGER, initname AS STRING, max AS INTEGER)
DECLARE FUNCTION getkey$ ()
DECLARE SUB locatecol (row AS INTEGER, column AS INTEGER, sentence AS STRING, colour AS INTEGER)
DECLARE SUB cross (squareno AS INTEGER, colour AS INTEGER)
DECLARE SUB boarddraw (colour AS INTEGER)
DECLARE SUB naught (squareno AS INTEGER, colour AS INTEGER)
DECLARE SUB paralagon (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, height AS INTEGER, colour AS INTEGER)

'** Declare Vareables

'Declare types, for game and colour files
  TYPE savefile
    playertype AS STRING * 10
    filename AS STRING * 21
    playername AS STRING * 21
    playerai AS STRING * 10
    boardcol AS INTEGER
    linecol AS INTEGER
    selectcol AS INTEGER
    playerturn AS INTEGER
    rounds AS LONG
    playerscore AS INTEGER
    playerwins AS LONG
    playerdraws AS LONG
    playerlosses AS LONG
    playercol AS INTEGER
   
  END TYPE
 
  TYPE savecolours
    player1col AS INTEGER
    player2col AS INTEGER
    boardcol AS INTEGER
    selectcol AS INTEGER
    linecol AS INTEGER
  END TYPE

'declare file varealbes
  DIM coloursave AS savecolours
  DIM Loaded(1 TO 2) AS savefile
  DIM file AS savefile
 
'declare player vareables
  DIM playerscore(1 TO 2) AS INTEGER
  DIM playerwins(1 TO 2) AS LONG
  DIM playerdraws(1 TO 2) AS LONG
  DIM playerlosses(1 TO 2) AS LONG
  DIM lists(9) AS INTEGER
  DIM filenum(11) AS INTEGER
  DIM filename(11) AS STRING
 
'declare tmp, 2 dimentional vareables
  DIM tmpnum(1 TO 4) AS INTEGER
  DIM tmpname(1 TO 3) AS STRING 'to account for pressing exit (see section for details)
  DIM tmpai(1 TO 2) AS STRING
  DIM tmptype(1 TO 2) AS STRING
 
'declare multi-dimentional vareables
  DIM board(3, 3) AS INTEGER
  DIM playertype(1 TO 2) AS STRING
  DIM playername(1 TO 2) AS STRING
  DIM playerai(1 TO 2) AS STRING
  DIM playercol(1 TO 2) AS INTEGER
  DIM boardno(9)  AS INTEGER
  DIM boardnoold(9) AS INTEGER
  DIM move(4) AS INTEGER
  DIM norc2(1 TO 2) AS STRING

'declare rounds vareables as long so as max is 999,999,999
  DIM rounds AS LONG
  DIM oldrounds AS LONG
 
'declare string vareables
  DIM ky AS STRING
  DIM tmpcol AS STRING
  DIM norc AS STRING
  DIM heading AS STRING
  DIM winner AS STRING
  DIM keypress AS STRING
 
'declare integer vareables
  DIM tmp AS INTEGER
  DIM tmp2 AS INTEGER
  DIM colmenuup AS INTEGER
  DIM colchange AS INTEGER
  DIM playerturn AS INTEGER
  DIM turn AS INTEGER
  DIM boardplace AS INTEGER
  DIM endgame AS INTEGER
  DIM I AS INTEGER
  DIM entrapment AS INTEGER
  DIM x AS INTEGER
  DIM y AS INTEGER
  DIM xb AS INTEGER
  DIM yb AS INTEGER
  DIM col AS INTEGER
  DIM row AS INTEGER
  DIM rename AS INTEGER
  DIM exited AS INTEGER
  DIM initial AS INTEGER
  DIM ingame AS INTEGER
  DIM inplay AS INTEGER
  DIM menuplace AS INTEGER
  DIM norcai AS INTEGER '(1 = crosses, 4 = naughts)
  DIM squaresused AS INTEGER
  DIM boardcol AS INTEGER
  DIM linecol AS INTEGER
  DIM selectcol AS INTEGER
  DIM gen AS INTEGER
  
'set constants for inkey statements
  CONST enter = 13, escape = 27, Space = 32, Backspace = 8
  CONST Downarrow = 80, Uparrow = 72, Leftarrow = 75, Rightarrow = 77
  CONST excl = 33, andsign = 36, asterisk = 42, hyphen = 45, comma = 44
  CONST hash = 35, percent = 37, dollar = 36, attherateof = 64, hat = 94, apostraphy = 39, brac1 = 40, brac2 = 41, colon = 58
  CONST fullstop = 46, lessthan = 60, greaterthan = 62, square1 = 91, square2 = 93, curv1 = 123, curv2 = 125, plus = 43, underline = 95, equal = 61
  CONST backslash = 92, forardslash = 47, verticleline = 124, semicolon = 59, quotations = 34, question = 63
 
  RANDOMIZE TIMER
  SCREEN 12
  
'** load colour data from file
  filenum(1) = FREEFILE
  OPEN "nccolour.sav" FOR RANDOM AS filenum(1) LEN = LEN(coloursave)
  GET filenum(1), 1, coloursave
  IF coloursave.selectcol < 1 OR coloursave.selectcol > 15 THEN coloursave.selectcol = 14
  IF coloursave.linecol < 1 OR coloursave.linecol > 15 THEN coloursave.linecol = 15
  IF coloursave.boardcol < 1 OR coloursave.boardcol > 15 THEN coloursave.boardcol = 1
  IF coloursave.player1col < 1 OR coloursave.player1col > 15 THEN coloursave.player1col = 4
  IF coloursave.player2col < 1 OR coloursave.player2col > 15 THEN coloursave.player2col = 9
  PUT filenum(1), 1, coloursave
  CLOSE filenum(1)
  boardcol = coloursave.boardcol
  selectcol = coloursave.selectcol
  linecol = coloursave.linecol
  playercol(1) = coloursave.player1col
  playercol(2) = coloursave.player2col
  
'initialize vareables
  FOR I = 1 TO 2
    playerai(I) = "average"
    playertype(I) = "human"
  NEXT I
  gen = 1
  exited = 0
  menuplace = 1
  playername(1) = "Will"
  playername(2) = "Bismark"

'** Initialize board and menu
menustart:
  
  'CLOSE 'close any open files from load/save menu 'fix
  
  LINE (100, 80)-(540, 370), 0, BF
  CALL boarddraw(boardcol)

'initialize board
  FOR I = 1 TO 3
    FOR K = 1 TO 3
      board(I, K) = 0
    NEXT K
  NEXT I
 
  endgame = 0

'** place random game on the board in there is no finished round
  FOR I = 1 TO 9
    IF gen = 1 THEN 'if generate vareable gen = 1 then generate board
      DO
        tmp = INT(9 * RND + 1)
      LOOP UNTIL boardno(tmp) = 0
      IF I = 1 OR I = 3 OR I = 5 OR I = 7 OR I = 9 THEN boardno(tmp) = 1 ELSE boardno(tmp) = 4
      IF boardno(tmp) = 1 THEN CALL cross(tmp, playercol(1)) ELSE CALL naught(tmp, playercol(2))
    ELSE
        IF boardno(I) = 1 THEN CALL cross(I + 0, playercol(1))
        IF boardno(I) = 4 THEN CALL naught(I + 0, playercol(2))
        tmp = I
    END IF
    
'convert list to table
    SELECT CASE tmp
      CASE 1 TO 3
        board(tmp, 1) = boardno(tmp)

      CASE 4 TO 6
        board(tmp - 3, 2) = boardno(tmp)
     
      CASE 7 TO 9
        board(tmp - 6, 3) = boardno(tmp)
    END SELECT

'test code copied from below

    'Test for a Vertical win
    FOR J = 1 TO 3
      tmp = 0
      FOR K = 1 TO 3
        tmp = tmp + board(J, K)
      NEXT K
      IF tmp = 3 OR tmp = 12 THEN '3 is a win for crosses, 12 is a win for naughts
        IF tmp = 3 THEN endgame = 1 ELSE endgame = 2
        LINE (J * 140 + 129, 36)-(J * 140 + 134, 444), linecol, BF
      END IF
    NEXT J
  

    'Test for a Horisontal win
    FOR K = 1 TO 3
      tmp = 0
      FOR J = 1 TO 3
        tmp = tmp + board(J, K)
      NEXT J
      IF tmp = 3 OR tmp = 12 THEN  '3 is a win for crosses, 12 is a win for naughts
        IF tmp = 3 THEN endgame = 1 ELSE endgame = 2
        LINE (205, K * 140 - 42)-(614, K * 140 - 37), linecol, BF
      END IF
    NEXT K

'Test for a Diagonal win
    tmp = board(1, 1) + board(2, 2) + board(3, 3) 'first diagonal
    IF tmp = 3 OR tmp = 12 THEN '3 is a win for crosses, 12 is a win for naughts
      IF tmp = 3 THEN endgame = 1 ELSE endgame = 2
      FOR L = 0 TO 7
        LINE (206 + L, 36)-(607 + L, 444), linecol
      NEXT L
    END IF
  
    tmp = board(3, 1) + board(2, 2) + board(1, 3) 'second diagonal
    IF tmp = 3 OR tmp = 12 THEN '3 is a win for crosses, 12 is a win for naughts
      IF tmp = 3 THEN endgame = 1 ELSE endgame = 2
      FOR L = 0 TO 7
        LINE (607 + L, 36)-(206 + L, 444), linecol
      NEXT L
    END IF
   
    IF endgame <> 0 AND gen = 1 THEN EXIT FOR 'if there is a win, stop
  NEXT I

  'saves boardplaces
  FOR I = 1 TO 9
    boardnoold(I) = boardno(I)
  NEXT I

  IF gen = 0 THEN LINE (x + 4, y + 4)-(x + 136, y + 136), selectcol + 0, B 'select last chosen square
  gen = 2

'** Menu Code

menu:
 
'keep count vareables below 999,999,999
  IF rounds > 999999999 THEN rounds = 999999999
  FOR I = 1 TO 2
    IF playerwins(I) > 999999999 THEN playerwins(I) = 999999999
    IF playerdraws(I) > 999999999 THEN playerdraws(I) = 999999999
    IF playerlosses(I) > 999999999 THEN playerlosses(I) = 999999999
  NEXT I
 
'clear top row
  CALL locatecol(1, 1, "                                                                                     ", 0)

'display scores
  IF ingame = 1 THEN
    CALL locatecol(17, 3, "SCORES", 14)
    FOR I = 1 TO 2
      CALL locatecol(12 + I * 6, 1, "Player " + LTRIM$(STR$(I)) + ": " + RTRIM$(playername(I)), playercol(I))
      CALL locatecol(13 + I * 6, 1, "Wins: " + STR$(playerwins(I)), boardcol)
      CALL locatecol(14 + I * 6, 1, "Losses: " + STR$(playerlosses(I)), boardcol)
      CALL locatecol(15 + I * 6, 1, "Draws: " + STR$(playerdraws(I)), boardcol)
      CALL locatecol(16 + I * 6, 1, "Total Score: " + STR$(playerwins(I)), boardcol)
    NEXT I
    
    winner = ""
    FOR I = 1 TO 2
      IF playerscore(I) = 1 THEN winner = "winner: " + playername(I)
    NEXT I
    IF winner = "" THEN winner = "no winner"
    CALL locatecol(1, 36, "           ", 0)
    CALL locatecol(1, 1, "Round: " + LTRIM$(STR$(rounds)) + "                     ", 9)
    CALL locatecol(1, 1, "Round: " + LTRIM$(STR$(rounds)) + ", " + winner, 9)
    
  END IF
 
'display name and creator
  IF rounds < 100000000 THEN
    IF rounds < 1000 THEN CALL locatecol(1, 37, "Naughts and Crosses (C) 1999 William Denniss", 4) ELSE CALL locatecol(1, 40, "Naughts and Crosses  (C) William Denniss", 4)
  ELSE
    CALL locatecol(1, 43, "Naughts and Crosses by William Denniss", 4)
  END IF

'menu code
  CALL locatecol(3, 3, "MENU", 4)
  CALL locatecol(5, 3, "New Game", 4)
  CALL locatecol(9, 3, "Load Game", 4)
  CALL locatecol(10, 3, "Colours", 4)
  CALL locatecol(11, 3, "Exit", 4)
 
  IF ingame = 1 THEN
    CALL locatecol(6, 3, "Rename", 4)
    CALL locatecol(7, 3, "Continue", 4)
    CALL locatecol(8, 3, "Save Game", 4)
  ELSE
    CALL locatecol(6, 3, "Rename", 8)
    CALL locatecol(7, 3, "Continue", 8)
    CALL locatecol(8, 3, "Save Game", 8)
  END IF

  FOR I = 5 TO 12
    CALL locatecol(I, 1, " ", 4)
  NEXT I
 
  CALL locatecol(4 + menuplace, 1, ">", 9)
 
  DO
    TIMER ON
    ON TIMER(30) GOSUB SS
    FOR I = 1 TO 30
      ky = INKEY$
    NEXT I
    
    ky = getkey
    IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
   
    TIMER OFF
   
    IF ky = "up" OR ky = "right" OR ky = "down" OR ky = "left" OR ky = "escape" THEN
     
      IF ky = "up" OR ky = "left" THEN menuplace = menuplace - 1
      IF ky = "down" OR ky = "right" THEN menuplace = menuplace + 1
     
      IF ingame = 1 THEN
        IF menuplace = 0 THEN menuplace = 7
        IF menuplace = 8 THEN menuplace = 1
      ELSE
        IF menuplace = 0 THEN menuplace = 7
        IF menuplace = 8 THEN menuplace = 1
       
        IF ky = "down" OR ky = "left" THEN  'If there is no game then menu skips continue etc
          IF menuplace = 2 THEN menuplace = 5
        ELSEIF ky = "up" OR ky = "right" THEN
          IF menuplace = 4 THEN menuplace = 1
        ELSE
        END IF

      END IF
     
      IF ky = "escape" THEN menuplace = 7
      FOR I = 5 TO 12
        CALL locatecol(I, 1, " ", 4)
      NEXT I
     
      CALL locatecol(4 + menuplace, 1, ">", 9)
    END IF
  LOOP UNTIL ky = "enter"
  

'** Continue Game code

  IF menuplace = 3 THEN
    
      turn = 1
      playerturn = rounds MOD 2
      boardplace = 1
      endgame = 0
     
      FOR J = 1 TO 3
        FOR K = 1 TO 3
          board(J, K) = 0
        NEXT K
      NEXT J

      FOR I = 1 TO 9
        boardno(I) = 0
      NEXT I
    

'** Load and Save Game code
  ELSEIF menuplace = 4 OR menuplace = 5 THEN
    exited = 0

    CALL box(100, 80, 540, 370, 10, 4, 0)
    SELECT CASE menuplace
      CASE 4
        heading = "Save Game"
      CASE 5
        heading = "Load Game"
    END SELECT
    menuplace = 1

reloadfiles:
    CLOSE 'closes any open files

'create files if they don't exist
    FOR I = 1 TO 10
      filenum(I) = FREEFILE
      filename(I) = "ncsave" + LTRIM$(STR$(I)) + ".sav"
     
      OPEN filename(I) FOR RANDOM AS filenum(I) LEN = LEN(Loaded(1))
      numrecs = LOF(filenum(I)) \ LEN(Loaded(1))
      GET filenum(I), 1, file
      
      IF RTRIM$(file.filename) = "" OR numrecs = 0 THEN
        file.filename = "Save File " + LTRIM$(STR$(I))
        PUT filenum(I), 1, file
      END IF
      filename(I) = file.filename
      CALL locatecol(I + 10, 20, file.filename, 1) 'no rtrim so as to clear text in the event of a corruption
    NEXT I
   
    CALL locatecol(8, 17, heading, 4)
    CALL locatecol(9, 40, "Press Esc to exit", 14)
    menuplace = menuplace + 1
    initial = 1
    
    DO
      IF initial = 1 THEN 'see if first file has no data
        
        ky = "up"
        
      ELSE
        ky = getkey
        IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
      END IF
      IF ky = "escape" THEN
        exited = 1
        IF heading = "Save Game" THEN menuplace = 4 ELSE menuplace = 5
        GOTO menustart
      END IF
      IF ky = "left" OR ky = "up" THEN menuplace = menuplace - 1
      IF ky = "right" OR ky = "down" THEN menuplace = menuplace + 1
      IF menuplace = 0 THEN menuplace = 10
      IF menuplace = 11 THEN menuplace = 1
      IF ky = "down" OR ky = "up" OR ky = "left" OR ky = "right" THEN
        filenum(11) = FREEFILE
        filename(11) = "ncsave" + LTRIM$(STR$(menuplace)) + ".sav"
        OPEN filename(11) FOR RANDOM AS filenum(11) LEN = LEN(Loaded(1))
        GET filenum(11), 1, Loaded(1)
        oldrounds = Loaded(1).rounds
        IF Loaded(1).playercol = 0 THEN CALL locatecol(22, 20, "Empty file!", 14) ELSE CALL locatecol(22, 20, "                ", 14)
        CLOSE filenum(11)
        
      END IF
      IF initial = 0 THEN
        FOR I = 1 TO 10
          CALL locatecol(I + 10, 18, " ", 4)
        NEXT I
      ELSE
        initial = 0
      END IF
      IF menuplace > 10 THEN CALL locatecol(menuplace + 11, 18, ">", 4) ELSE CALL locatecol(menuplace + 10, 18, ">", 4)
      IF ky = "enter" AND heading = "Load Game" THEN
      
        CALL box(123, 200, 515, 260, 10, 4, 0)
        CALL locatecol(15, 19, "Are you sure you want to load this game? Y/N", 1)
        DO
          ky = getkey
          IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
          IF ky = "escape" THEN ky = "n"
        LOOP UNTIL ky = "n" OR ky = "y"
        IF ky = "n" THEN
          LINE (123, 200)-(515, 260), 0, BF
          
          GOTO reloadfiles
        END IF
        GET filenum(menuplace), 1, Loaded(1)
        GET filenum(menuplace), 2, Loaded(2)
        oldrounds = Loaded(1).rounds
        
        IF Loaded(1).playercol = 0 THEN
          CALL locatecol(15, 19, "                 Empty File!                ", 1)
          SLEEP 1
          LINE (123, 200)-(515, 260), 0, BF
          
          GOTO reloadfiles
        END IF
        IF oldrounds >= 0 AND oldrounds <= 999999999 AND INT(oldrounds) = oldrounds AND Loaded(1).playercol <> 0 AND Loaded(2).playercol <> 0 THEN
          CALL locatecol(15, 19, "                Game Loaded!                ", 1)
         
'check for corruption
          FOR I = 1 TO 2
            IF RTRIM$(Loaded(I).playerai) <> "average" AND RTRIM$(Loaded(I).playerai) <> "impossible" AND RTRIM$(Loaded(I).playerai) <> "stupid" THEN GOTO corrupt
            IF RTRIM$(Loaded(I).playertype) <> "human" AND RTRIM$(Loaded(I).playertype) <> "computer" THEN GOTO corrupt
            IF Loaded(I).playercol < 1 OR Loaded(I).playercol > 15 THEN GOTO corrupt
          NEXT I
          IF Loaded(1).selectcol < 1 OR Loaded(1).selectcol > 15 THEN GOTO corrupt
          IF Loaded(1).linecol < 1 OR Loaded(1).linecol > 15 THEN GOTO corrupt
          IF Loaded(1).boardcol < 1 OR Loaded(1).boardcol > 15 THEN GOTO corrupt
         
          'load game data from selected file
          FOR I = 1 TO 2
            playertype(I) = RTRIM$(Loaded(I).playertype)
            playername(I) = RTRIM$(Loaded(I).playername)
            playercol(I) = Loaded(I).playercol
            playerwins(I) = Loaded(I).playerwins
            playerdraws(I) = Loaded(I).playerdraws
            playerlosses(I) = Loaded(I).playerlosses
            playerai(I) = RTRIM$(Loaded(I).playerai)
            playerscore(I) = Loaded(I).playerscore
            
          NEXT I
          playerturn = Loaded(1).playerturn
          boardcol = Loaded(1).boardcol
          linecol = Loaded(1).linecol
          selectcol = Loaded(1).selectcol
          file.filename = Loaded(1).filename
          rounds = Loaded(1).rounds
          ingame = 1
        
        ELSE

corrupt:
          CALL locatecol(15, 19, "               File Corrupt!                ", 1)
          tmpname(1) = "ncsave" + LTRIM$(STR$(menuplace)) + ".sav"
          CLOSE filenum(menuplace)
          KILL tmpname(1)
          SLEEP 1
          LINE (123, 200)-(515, 260), 0, BF
          GOTO reloadfiles
        END IF
        SLEEP 1
        exited = 1
      END IF
    
      IF ky = "enter" AND heading = "Save Game" THEN
       
        GET filenum(menuplace), 1, file
        CALL locatecol(menuplace + 10, 20, RTRIM$(file.filename), 4)
        tmpname(1) = RTRIM$(file.filename)
        tmpname(1) = nameinput(20, menuplace + 10, RTRIM$(filename(menuplace)), 21)
        IF MID$(tmpname(1), LEN(tmpname(1)), 1) = "\" THEN
          CALL locatecol(menuplace + 10, 20, "                      ", 0)
          CALL locatecol(menuplace + 10, 20, file.filename, 4)
          GOTO dontsave
        ELSE
          file.filename = tmpname(1)
        END IF
        CALL box(170, 200, 486, 260, 10, 4, 0)
        CALL locatecol(15, 25, "Are you sure you want to save? Y/N", 1)
        DO
          ky = getkey
          IF ky = "escape" THEN ky = "n"
        LOOP UNTIL ky = "n" OR ky = "y"
        IF ky = "n" THEN
          LINE (170, 200)-(486, 260), 0, BF
          GOTO reloadfiles
        END IF
        CALL locatecol(15, 25, "            Game Saved!           ", 1)

        'save game data to selected file
        FOR I = 1 TO 2
          Loaded(I).playerscore = playerscore(I)
          Loaded(I).playertype = playertype(I)
          Loaded(I).playername = playername(I)
          Loaded(I).playercol = playercol(I)
          Loaded(I).playerwins = playerwins(I)
          Loaded(I).playerdraws = playerdraws(I)
          Loaded(I).playerlosses = playerlosses(I)
          Loaded(I).playerai = playerai(I)
        NEXT I
        Loaded(1).playerturn = playerturn
        Loaded(1).boardcol = boardcol
        Loaded(1).linecol = linecol
        Loaded(1).selectcol = selectcol
        Loaded(1).filename = file.filename
        Loaded(1).rounds = rounds
        PUT filenum(menuplace), 1, Loaded(1)
        PUT filenum(menuplace), 2, Loaded(2)
        SLEEP 1
       
        exited = 1
dontsave:
        CALL locatecol(menuplace + 10, 20, file.filename, 1)
    
      END IF

    LOOP WHILE exited = 0
    exited = 0
    IF heading = "Save Game" THEN menuplace = 4 ELSE menuplace = 5
    GOTO menustart

'** Colour select code

  ELSEIF menuplace = 6 THEN
    LINE (0, 255)-(197, 500), 0, BF
    CALL locatecol(19, 1, "COLOURS", 9)
    CALL locatecol(20, 1, "Press escape to exit menu", 8)
    CALL locatecol(22, 5, "Player 1", 4)
    CALL locatecol(22, 1, "<--", 1)
    CALL locatecol(22, 14, "-->", 1)
   
    tmpcol = coltrans(playercol(1))
    CALL locatecol(24, 5, tmpcol, playercol(1))
    menuplace = 1
    colmenuup = 1'the cursor is on the first part of the menu
    DO
      ky = getkey
      IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
      IF ky = "up" OR ky = "down" OR ky = "enter" THEN
        IF menuplace = 7 THEN GOTO exitcol
        IF menuplace = 6 THEN
          boardcol = 1
          selectcol = 14
          linecol = 15
          playercol(1) = 4
          playercol(2) = 9
          CALL locatecol(24, 1, "Default colours restored", 14)
          SLEEP 1
          CALL locatecol(24, 1, "                        ", 0)
          GOTO exitdefault
        END IF
        IF colmenuup = 1 THEN colmenuup = 0 ELSE colmenuup = 1
        IF colmenuup = 1 THEN
          CALL locatecol(22, 14, "-->", 1)
          CALL locatecol(22, 1, "<--", 1)
          CALL locatecol(24, 19, "   ", 9)
          CALL locatecol(24, 1, "   ", 9)
          SELECT CASE menuplace
            CASE 1
              CALL locatecol(22, 5, "Player 1", 4)
            CASE 2
              CALL locatecol(22, 5, "Player 2", 4)
            CASE 3
              CALL locatecol(22, 5, " Board  ", 4)
            CASE 4
              CALL locatecol(22, 5, " Cursor ", 4)
            CASE 5
              CALL locatecol(22, 5, "Win Line", 4)
          END SELECT
          
        ELSE
          CALL locatecol(22, 14, "   ", 9)
          CALL locatecol(22, 1, "   ", 9)
          CALL locatecol(24, 19, "-->", 1)
          CALL locatecol(24, 1, "<--", 1)

          SELECT CASE menuplace
            CASE 1
              CALL locatecol(22, 5, "Player 1", 1)
            CASE 2
              CALL locatecol(22, 5, "Player 2", 1)
            CASE 3
              CALL locatecol(22, 5, " Board  ", 1)
            CASE 4
              CALL locatecol(22, 5, " Cursor ", 1)
            CASE 5
              CALL locatecol(22, 5, "Win Line", 1)
          END SELECT

        END IF
      END IF

      IF ky = "left" OR ky = "right" THEN

        IF colmenuup = 1 THEN
          IF ky = "left" THEN
            menuplace = menuplace - 1
            CALL locatecol(22, 1, "<--", 4)
            CALL locatecol(22, 14, "-->", 1)
         
          ELSE
            menuplace = menuplace + 1
            CALL locatecol(22, 1, "<--", 1)
            CALL locatecol(22, 14, "-->", 4)
         
          END IF
          IF menuplace = 8 THEN menuplace = 1
          IF menuplace = 0 THEN menuplace = 7
          CALL locatecol(24, 5, "             ", 0)
          SELECT CASE menuplace
            CASE 1
              CALL locatecol(22, 5, "Player 1", 4)
              tmpcol = coltrans(playercol(1) + 0)
              CALL locatecol(24, 5, tmpcol, playercol(1) + 0)
              colchange = playercol(1)

            CASE 2
              CALL locatecol(22, 5, "Player 2", 4)
              tmpcol = coltrans(playercol(2) + 0)
              CALL locatecol(24, 5, tmpcol, playercol(2) + 0)
              colchange = playercol(2)
           
            CASE 3
              CALL locatecol(22, 5, " Board  ", 4)
              tmpcol = coltrans(boardcol + 0)
              CALL locatecol(24, 5, tmpcol, boardcol + 0)
              colchange = boardcol
          
            CASE 4
              CALL locatecol(22, 5, " Cursor ", 4)
              tmpcol = coltrans(selectcol + 0)
              CALL locatecol(24, 5, tmpcol, selectcol + 0)
              colchange = selectcol
           
            CASE 5
              CALL locatecol(22, 5, "Win Line", 4)
              tmpcol = coltrans(linecol + 0)
              CALL locatecol(24, 5, tmpcol, linecol + 0)
              colchange = linecol
            CASE 6
              CALL locatecol(22, 5, "Default ", 4)
            CASE 7
              CALL locatecol(22, 5, " Exit   ", 4)
          END SELECT
        
        ELSE
          IF ky = "right" OR ky = "left" THEN
            IF ky = "left" THEN
              CALL locatecol(24, 1, "<--", 4)
              CALL locatecol(24, 19, "-->", 1)
              colchange = colchange - 1
            ELSEIF ky = "right" THEN
              colchange = colchange + 1
              CALL locatecol(24, 1, "<--", 1)
              CALL locatecol(24, 19, "-->", 4)
           
            END IF
            IF colchange = 16 THEN colchange = 1
            IF colchange = 0 THEN colchange = 15

            CALL locatecol(24, 5, "              ", 0)
            tmpcol = coltrans(colchange + 0)
            CALL locatecol(24, 5, tmpcol, colchange + 0)
           
            SELECT CASE menuplace
              CASE 1
                playercol(1) = colchange
              CASE 2
                playercol(2) = colchange
              CASE 3
                boardcol = colchange
              CASE 4
                selectcol = colchange
              CASE 5
                linecol = colchange
            END SELECT
           
         
          END IF
        END IF
      END IF
      
exitdefault:
   
    LOOP UNTIL ky = "escape"

exitcol:
   
'save colour data to file
   filenum(1) = FREEFILE
   OPEN "nccolour.sav" FOR RANDOM AS filenum(1) LEN = LEN(coloursave)
   coloursave.boardcol = boardcol
   coloursave.selectcol = selectcol
   coloursave.linecol = linecol
   coloursave.player1col = playercol(1)
   coloursave.player2col = playercol(2)
   PUT filenum(1), 1, coloursave
   CLOSE filenum(1)
  
   menuplace = 6
   LINE (0, 290)-(197, 500), 0, BF
   GOTO menu


'** Exit Game code
  ELSEIF menuplace = 7 THEN
    menuplace = 2
    CALL locatecol(14, 3, "Exit to system?", 4)
    CALL locatecol(15, 3, "Yes    No", 4)
    CALL locatecol(15, 8, ">", 9)
    CALL locatecol(11, 1, " ", 0)
    DO
      ky = getkey
      IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
      IF ky = "y" THEN
       menuplace = 1
       ky = "enter"
      END IF
      IF ky = "n" OR ky = "escape" THEN
        menuplace = 2
        ky = "enter"
      END IF
      IF ky = "left" OR ky = "right" OR ky = "up" OR ky = "down" THEN IF menuplace = 1 THEN menuplace = 8 ELSE menuplace = 1
      CALL locatecol(15, 1, " ", 9)
      CALL locatecol(15, 8, " ", 9)
      CALL locatecol(15, menuplace, ">", 9)
   
    LOOP UNTIL ky = "enter"
    IF menuplace = 1 THEN
      CLS
      SCREEN 0
      CALL locatecol(1, 1, "Thank you for playing Naughts and Crosses (C) 1999 William Denniss", 1)
      END
    ELSE
      CALL locatecol(14, 1, "                  ", 4)
      CALL locatecol(15, 1, "                  ", 4)
      menuplace = 7
      GOTO menu
    END IF


'** New Game code and Rename code
  ELSEIF menuplace = 1 OR menuplace = 2 THEN
    IF menuplace = 2 THEN rename = 1 ELSE rename = 0
    LINE (0, 255)-(197, 500), 0, BF
    FOR player = 1 TO 2
      tmptype(player) = playertype(player)
      tmpai(player) = playerai(player)
      tmpname(player) = playername(player)
      COLOR 9: LOCATE 19, 7
      PRINT player
      CALL locatecol(19, 1, "Player", 9)
      CALL locatecol(21, 3, "Name:                 ", 9)
      CALL locatecol(21, 9, playername(player), 4)
      CALL locatecol(22, 3, "Human [ ]  Computer [ ]", 9)
      IF rename = 1 AND player = 2 THEN CALL locatecol(23, 3, "Rename->", 9) ELSE CALL locatecol(23, 3, "Next->", 9)
      CALL locatecol(24, 3, "Computer Intellegence:", 9)
      CALL locatecol(25, 3, "Stupid     [ ]", 9)
      CALL locatecol(26, 3, "Average    [ ]", 9)
      CALL locatecol(27, 3, "Impossible [ ]", 9)
      CALL locatecol(28, 3, "Exit", 9)
      CALL locatecol(23, 1, ">", 4)
      IF tmptype(player) = "computer" THEN
       CALL locatecol(22, 24, "X", 4)
      ELSE
        CALL locatecol(22, 10, "X", 4)
      END IF
                               
      SELECT CASE tmpai(player)
        CASE "stupid"
          CALL locatecol(25, 15, "X", 4)
        CASE "average"
          CALL locatecol(26, 15, "X", 4)
        CASE "impossible"
          CALL locatecol(27, 15, "X", 4)
      END SELECT
           
      menuplace = 3
      DO
        ky = getkey
        IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
        IF ky = "up" OR ky = "left" THEN menuplace = menuplace - 1
        IF ky = "down" OR ky = "right" THEN menuplace = menuplace + 1
        IF menuplace = 0 OR ky = "escape" THEN menuplace = 7
        IF menuplace = 8 THEN menuplace = 1
        FOR I = 21 TO 28
          CALL locatecol(I + 0, 1, " ", 9)
        NEXT I
             
        IF menuplace < 4 THEN CALL locatecol(20 + menuplace, 1, ">", 4) ELSE CALL locatecol(21 + menuplace, 1, ">", 4)
        IF ky = "enter" THEN
          IF menuplace = 2 THEN
            CALL locatecol(22, 3, "Human [ ]  Computer [ ]", 9) 'do menu item
            IF tmptype(player) = "human" THEN
                tmptype(player) = "computer"
                CALL locatecol(22, 24, "X", 4)
            ELSE
                tmptype(player) = "human"
                CALL locatecol(22, 10, "X", 4)
            END IF
          END IF
               
          IF menuplace > 3 AND menuplace < 7 THEN
            FOR I = 25 TO 27
            CALL locatecol(I, 15, " ", 4)
            NEXT I
          END IF

          SELECT CASE menuplace
            CASE 4
              CALL locatecol(25, 15, "X", 4)
              tmpai(player) = "stupid"
            CASE 5
              CALL locatecol(26, 15, "X", 4)
              tmpai(player) = "average"
            CASE 6
              CALL locatecol(27, 15, "X", 4)
              tmpai(player) = "impossible"
          END SELECT
               
          IF menuplace = 1 THEN
            CALL locatecol(21, 2, ">", 4)
            COLOR 4
            LOCATE 10, 26
            tmpname(3) = nameinput(9, 21, tmpname(player), 15)
            IF MID$(tmpname(3), LEN(tmpname(3)), 1) = "\" THEN
              CALL locatecol(21, 9, "                ", 0)
              CALL locatecol(21, 9, tmpname(player), 4)
              CALL locatecol(21, 19, " ", 0)
         
            ELSE
              tmpname(player) = tmpname(3)
            END IF
            CALL locatecol(21, 2, " ", 4)
          END IF
        END IF
           
      LOOP UNTIL ky = "enter" AND menuplace = 3 OR ky = "enter" AND menuplace = 7
           
      IF menuplace = 7 THEN
        LINE (0, 290)-(197, 500), 0, BF
        IF rename = 1 THEN menuplace = 2 ELSE menuplace = 1
        GOTO menu
      END IF
          
    NEXT player
         
    FOR player = 1 TO 2
      playername(player) = RTRIM$(tmpname(player))
      playertype(player) = tmptype(player)
      playerai(player) = tmpai(player)
    NEXT player
       
    IF rename = 0 THEN 'initialize vareables
      rounds = 0
      ingame = 0
      turn = 1
      boardplace = 1
      endgame = 0
      ingame = 1
      playerturn = 0
      FOR I = 1 TO 2
        playerwins(I) = 0
        playerlosses(I) = 0
        playerdraws(I) = 0
        playerscore(I) = 0
        
      NEXT I
      FOR I = 1 TO 9
        boardno(I) = 0
      NEXT I

      FOR J = 1 TO 3
        FOR K = 1 TO 3
          board(J, K) = 0
        NEXT K
      NEXT J
    END IF
               
    CALL locatecol(23, 1, " ", 9)
    FOR I = 19 TO 28
      CALL locatecol(I + 0, 1, "                         ", 9)
    NEXT I
   
    IF rename = 1 THEN
      menuplace = 2
      GOTO menu
    END IF


  END IF

  CALL boarddraw(boardcol + 0)
  x = 200
  y = 30
  place = 1



'** Game Code
  LINE (0, 0)-(197, 255), 0, BF
  CALL locatecol(1, 1, "                                                                                ", 0)
  entrapment = 0

  FOR I = 1 TO 2
    IF playerturn MOD 2 = I - 1 THEN norc = "crosses" ELSE norc = "naughts"
    norc2(I) = playername(I) + " (" + norc + ")"
  NEXT I
 
  IF LEN(norc2(1)) > LEN(norc2(2)) THEN
    CALL locatecol(5, 1, norc2(1), playercol(1))
    CALL locatecol(6, LEN(norc2(1)) \ 2 - 1, " vs ", boardcol)
    CALL locatecol(7, LEN(norc2(1)) \ 2 - LEN(norc2(2)) \ 2 + 1, norc2(2), playercol(2))
  ELSE
    CALL locatecol(7, 1, norc2(2), playercol(2))
    CALL locatecol(6, LEN(norc2(2)) \ 2 - 1, " vs ", boardcol)
    CALL locatecol(5, LEN(norc2(2)) \ 2 - LEN(norc2(1)) \ 2 + 1, norc2(1), playercol(1))
  END IF
 
  CALL locatecol(1, 1, "Round: " + LTRIM$(STR$(rounds + 1)) + "                   ", 4)

  DO
    norc = playername(playerturn MOD 2 + 1) + "'s turn ("
    IF turn \ 2 = 0 THEN norc = norc + "crosses)" ELSE norc = norc + "naughts)"
    CALL locatecol(1, 40, "                                    ", 0)
    CALL locatecol(1, 40, norc, playercol(playerturn MOD 2 + 1))
   
    IF playertype(playerturn MOD 2 + 1) = "human" THEN
  
'** Human Turn Code
      DO
        LINE (x + 4, y + 4)-(x + 136, y + 136), selectcol + 0, B
        ky = getkey
        IF ky = "space" THEN ky = "enter" 'Use space as alternative enter key
       
        IF ky = "escape" THEN
          CALL locatecol(10, 1, "Exit to menu? y/n", 4)
          SLEEP 1
          keypress = getkey
          CALL locatecol(10, 1, "                 ", 0)

          IF keypress = "y" THEN
            FOR I = 1 TO 9
              boardno(I) = boardnoold(I)
            NEXT I
           
            IF rounds < 1 THEN ingame = 0
            IF rounds < 1 THEN menuplace = 1 ELSE menuplace = 3
            CALL locatecol(1, 1, "                                                                                     ", 0)
            LINE (0, 0)-(197, 255), 0, BF
            GOTO menustart
          END IF
        END IF

  'cursor movement
        IF ky = "up" OR ky = "down" OR ky = "left" OR ky = "right" THEN
         
          LINE (x + 4, y + 4)-(x + 136, y + 136), selectcol + 0, B
          IF ky = "up" THEN
            DO
              IF boardplace <= 3 THEN
                boardplace = boardplace + 7
                IF boardplace = 10 THEN boardplace = 7
              ELSE boardplace = boardplace - 3
              END IF
            LOOP UNTIL boardno(boardplace) = 0
          END IF
     
          IF ky = "down" THEN
            DO
              IF boardplace >= 7 THEN
                boardplace = boardplace - 7
                IF boardplace = 0 THEN boardplace = 3
              ELSE boardplace = boardplace + 3
              END IF
            LOOP UNTIL boardno(boardplace) = 0
          END IF
         
          IF ky = "right" THEN boardplace = boardplace + 1
          IF ky = "left" THEN boardplace = boardplace - 1
          IF boardplace < 1 THEN boardplace = 9
          IF boardplace > 9 THEN boardplace = 1
     
          DO UNTIL boardno(boardplace) = 0
            IF ky = "right" THEN boardplace = boardplace + 1
            IF ky = "left" THEN boardplace = boardplace - 1
            IF boardplace < 1 THEN boardplace = 9
            IF boardplace > 9 THEN boardplace = 1
          LOOP
         
          SELECT CASE boardplace
            CASE 1 TO 3
              x = 200 + 140 * (boardplace - 1)
              y = 30
            CASE 4 TO 6
              x = 200 + 140 * (boardplace - 4)
              y = 170
            CASE 7 TO 9
              x = 200 + 140 * (boardplace - 7)
              y = 310
          END SELECT
         
          CALL eraseall
         
        END IF 'end of cursor movement
      LOOP UNTIL boardno(boardplace) = 0 AND ky = "enter"
    ELSE

'** Computer intellegence
     
      SLEEP 1
      ky = INKEY$
     
      IF ky = "" THEN ky = " " 'asc function requires a character
      IF ASC(ky) = escape THEN
        CALL locatecol(10, 1, "Exit to menu? y/n", 4)
        SLEEP 1
        keypress = getkey
        CALL locatecol(10, 1, "                 ", 0)

        IF keypress = "y" THEN
          FOR I = 1 TO 9
            boardno(I) = boardnoold(I)
          NEXT I
                        
          IF rounds < 1 THEN ingame = 0
          IF rounds < 1 THEN menuplace = 1 ELSE menuplace = 3
          CALL locatecol(1, 1, "                                                                                     ", 0)
          LINE (0, 0)-(197, 255), 0, BF
          GOTO menustart
        END IF
      END IF
     
      norcai = (turn - 1) * 3 + 1 'fixed
      LINE (x + 4, y + 4)-(x + 136, y + 136), selectcol + 0, B

'Test for a win oppertunity
     
      'determine if computer will test for a win oppertunity depending on ai level
      tmp = 0
      SELECT CASE playerai(playerturn MOD 2 + 1)
        CASE "stupid"
          IF INT(3 * RND + 1) = 1 THEN tmp = 1
        CASE "average"
          IF INT(7 * RND + 1) = 1 THEN tmp = 1
      END SELECT
     
      IF tmp = 0 THEN
        
        'Test for a Vertical win oppertunity
        FOR J = 1 TO 3
          tmp = 0
         
          FOR K = 1 TO 3
            tmp = tmp + board(J, K)
          NEXT K
         
          IF tmp = 2 AND norcai = 1 THEN
            FOR K = 1 TO 3
              IF board(J, K) = 0 THEN
                boardplace = (K - 1) * 3 + J
                GOTO endai
              END IF
            NEXT K
          END IF

          IF tmp = 8 AND norcai = 4 THEN
            FOR K = 1 TO 3
              IF board(J, K) = 0 THEN
                boardplace = (K - 1) * 3 + J
                GOTO endai
              END IF
            NEXT K
          END IF
       
        NEXT J
      

        'Test for a Horisontal win oppertunity
        FOR K = 1 TO 3
          tmp = 0
         
          FOR J = 1 TO 3
            tmp = tmp + board(J, K)
          NEXT J
         
          IF tmp = 2 AND norcai = 1 THEN
            FOR J = 1 TO 3
              IF board(J, K) = 0 THEN
                boardplace = (K - 1) * 3 + J
                GOTO endai
              END IF
            NEXT J
          END IF
         
          IF tmp = 8 AND norcai = 4 THEN
            FOR J = 1 TO 3
              IF board(J, K) = 0 THEN
                boardplace = (K - 1) * 3 + J
                GOTO endai
              END IF
            NEXT J
          END IF
       
        NEXT K

        'Test for a Diagonal win oppertunity
        tmp = board(1, 1) + board(2, 2) + board(3, 3) 'first diagonal
       
        IF tmp = 2 AND norcai = 1 THEN
          FOR K = 1 TO 3
            IF board(K, K) = 0 THEN
              boardplace = (K - 1) * 3 + K
              GOTO endai
            END IF
          NEXT K
        END IF
       
        IF tmp = 8 AND norcai = 4 THEN
          FOR K = 1 TO 3
            IF board(K, K) = 0 THEN
              boardplace = (K - 1) * 3 + K
              GOTO endai
            END IF
          NEXT K
        END IF
      
        tmp = board(3, 1) + board(2, 2) + board(1, 3) 'second diagonal win
        IF tmp = 2 AND norcai = 1 THEN
         
          FOR K = 1 TO 3
            IF board(4 - K, K) = 0 THEN
              boardplace = (K - 1) * 3 + (4 - K)'JK (K - 1) * 3 + J
              GOTO endai
            END IF
          NEXT K
        END IF

        IF tmp = 8 AND norcai = 4 THEN
          FOR K = 1 TO 3
            IF board(4 - K, K) = 0 THEN
              boardplace = (K - 1) * 3 + (4 - K)'JK (K - 1) * 3 + J'boardplace = (4 - K) + (K - 1) * 3
              GOTO endai
            END IF
          NEXT K
        END IF
      END IF

'Test for a block oppertunity
      tmp = 0
     
      'determine if computer will test for a win oppertunity depending on ai level
      SELECT CASE playerai(playerturn MOD 2 + 1)
        CASE "stupid"
          IF INT(3 * RND + 1) = 1 THEN tmp = 1
        CASE "average"
          IF INT(7 * RND + 1) = 1 THEN tmp = 1
      END SELECT
       
      IF tmp = 0 THEN
   
        'Test for a Vertical block oppertunity
        FOR J = 1 TO 3
          tmp = 0
         
          FOR K = 1 TO 3
            tmp = tmp + board(J, K)
          NEXT K
         
          IF tmp = 2 AND norcai = 4 THEN
            FOR K = 1 TO 3
              IF board(J, K) = 0 THEN
                boardplace = (K - 1) * 3 + J
                GOTO endai
              END IF
            NEXT K
          END IF

          IF tmp = 8 AND norcai = 1 THEN
            FOR K = 1 TO 3
              IF board(J, K) = 0 THEN
                boardplace = (K - 1) * 3 + J
                GOTO endai
              END IF
            NEXT K
          END IF
       
        NEXT J
     

        'Test for a Horisontal block oppertunity
        FOR K = 1 TO 3
          tmp = 0
         
          FOR J = 1 TO 3
            tmp = tmp + board(J, K)
          NEXT J
         
          IF tmp = 2 AND norcai = 4 THEN
            FOR J = 1 TO 3
              IF board(J, K) = 0 THEN
                boardplace = (K - 1) * 3 + J
                GOTO endai
              END IF
            NEXT J
          END IF
          
          IF tmp = 8 AND norcai = 1 THEN
            FOR J = 1 TO 3
              IF board(J, K) = 0 THEN
                boardplace = (K - 1) * 3 + J
                GOTO endai
              END IF
            NEXT J
          END IF
      
        NEXT K

    'Test for a Diagonal block
        tmp = board(1, 1) + board(2, 2) + board(3, 3) 'first diagonal
       
        IF tmp = 2 AND norcai = 4 THEN
          FOR K = 1 TO 3
            IF board(K, K) = 0 THEN
              boardplace = (K - 1) * 3 + K
              GOTO endai
            END IF
          NEXT K
        END IF

        IF tmp = 8 AND norcai = 1 THEN
          FOR K = 1 TO 3
            IF board(K, K) = 0 THEN
              boardplace = (K - 1) * 3 + K
              GOTO endai
            END IF
          NEXT K
        END IF
        
        tmp = board(3, 1) + board(2, 2) + board(1, 3) 'second diagonal block
        IF tmp = 2 AND norcai = 4 THEN
          FOR K = 1 TO 3
            IF board(4 - K, K) = 0 THEN
              boardplace = (K - 1) * 3 + (4 - K)'JK (K - 1) * 3 + J'boardplace = (4 - K) + (K - 1) * 3
              GOTO endai
            END IF
          NEXT K
        END IF

        IF tmp = 8 AND norcai = 1 THEN
          FOR K = 1 TO 3
            IF board(4 - K, K) = 0 THEN
              boardplace = (K - 1) * 3 + (4 - K)'JK (K - 1) * 3 + J'boardplace = (4 - K) + (K - 1) * 3
              GOTO endai
            END IF
          NEXT K
        END IF
     
      END IF

'Test for traps, determin move

      'determine out who's turn it is
      squaresused = 0
      FOR I = 1 TO 9
        IF boardno(I) <> 0 THEN squaresused = squaresused + 1
      NEXT I

      tmp = 0

      IF playerai(playerturn MOD 2 + 1) = "impossible" AND squaresused = 1 THEN
        IF boardno(2) = 1 OR boardno(4) = 1 OR boardno(6) = 1 OR boardno(8) = 1 THEN
          boardplace = 5
          GOTO endai
        END IF
      END IF

      SELECT CASE playerai(playerturn MOD 2 + 1)
        CASE "stupid"
          IF INT(6 * RND + 1) <> 1 THEN tmp = 1
        CASE "average"
          IF INT(3 * RND + 1) <> 1 THEN tmp = 1
      END SELECT

      IF squaresused = 3 AND playerai(playerturn MOD 2 + 1) = "impossible" THEN

        IF boardno(4) = 1 AND boardno(2) = 1 THEN
          IF boardno(1) = 0 THEN
            boardplace = 1
            GOTO endai
          END IF
        END IF
        IF boardno(2) = 1 AND boardno(6) = 1 THEN
          IF boardno(3) = 0 THEN
            boardplace = 3
            GOTO endai
          END IF
        END IF
        IF boardno(6) = 1 AND boardno(8) = 1 THEN
          IF boardno(7) = 0 THEN
            boardplace = 9
            GOTO endai
          END IF
        END IF
        IF boardno(4) = 1 AND boardno(8) = 1 THEN
          IF boardno(7) = 0 THEN
            boardplace = 7
            GOTO endai
          END IF
        END IF
      END IF
     
      IF squaresused = 2 AND tmp = 0 AND board(2, 2) = 5 - norcai THEN
        entrapment = INT(3 * RND + 1)
       
        FOR I = 1 TO 9 STEP 2
          IF boardno(I) = 1 THEN
             
            IF entrapment <> 2 THEN
              boardplace = 10 - I
            ELSE
              tmp2 = (2 * RND + 1)
              SELECT CASE I
                CASE 1
                  IF tmp2 = 1 THEN boardplace = 8 ELSE boardplace = 6
                CASE 3
                  IF tmp2 = 1 THEN boardplace = 8 ELSE boardplace = 4
                CASE 7
                  IF tmp2 = 1 THEN boardplace = 2 ELSE boardplace = 6
                CASE 9
                  IF tmp2 = 1 THEN boardplace = 4 ELSE boardplace = 2
              END SELECT
                           
            END IF
            GOTO endai
                       
          END IF
        NEXT I
      END IF
     
      IF entrapment = 2 THEN 'copied from the anti-entrapment code below
        FOR K = 1 TO 3
          FOR J = 1 TO 3
            IF board(J, K) = 1 THEN
              tmp = ((K - 1) * 3 + J)
              SELECT CASE tmp
                CASE 1, 3, 7, 9
                  col = K
                  row = J
              END SELECT
            END IF
          NEXT J
        NEXT K
       
        FOR K = 1 TO 3
          FOR J = 1 TO 3
            IF board(J, K) = 1 THEN
              tmp = ((K - 1) * 3 + J)
              SELECT CASE tmp
                CASE 2, 8
                  row = K
                CASE 4, 6
                  col = J
              END SELECT
            END IF
          NEXT J
        NEXT K

        boardplace = (row - 1) * 3 + col
        IF boardno(boardplace) = 0 THEN
          entrapment = 0
          GOTO endai
        END IF
      END IF
     
      IF squaresused = 3 AND tmp = 0 AND board(2, 2) = 4 THEN

        IF board(3, 1) + board(2, 2) + board(1, 3) = 6 OR board(1, 1) + board(2, 2) + board(3, 3) = 6 THEN 'there must be the following setup: 2 crosses on corners in diagonal line, naughts in centre in which case a non corner is needed
            boardplace = INT(4 * RND + 1) * 2
            GOTO endai
        END IF
      END IF
    
     
'checking for traps or course
      IF squaresused = 1 AND tmp = 0 THEN
        IF board(1, 1) = 1 OR board(1, 3) = 1 OR board(3, 1) = 1 OR board(3, 3) = 1 THEN
          boardplace = 5
          GOTO endai
        END IF
      END IF
     
      'trap cross diag, naught middle, cross non-diag not inline with other cross counters the entrapment code
      IF squaresused = 3 AND tmp = 0 AND boardno(5) = 4 THEN
        IF boardno(1) = 1 OR boardno(3) = 1 OR boardno(7) = 1 OR boardno(9) = 1 THEN
          IF boardno(2) = 1 OR boardno(4) = 1 OR boardno(6) = 1 OR boardno(8) = 1 THEN
           
            FOR K = 1 TO 3
              FOR J = 1 TO 3
                IF board(J, K) <> 0 THEN
                  tmp = ((K - 1) * 3 + J)
                  SELECT CASE tmp
                    CASE 1, 3, 7, 9
                      col = J
                      row = K
                  END SELECT
                END IF
              NEXT J
            NEXT K
           
            FOR K = 1 TO 3
              FOR J = 1 TO 3
                IF board(J, K) <> 0 THEN
                  tmp = ((K - 1) * 3 + J)
                  SELECT CASE tmp
                    CASE 2, 8
                      row = K
                    CASE 4, 6
                      col = J
                  END SELECT
                END IF
              NEXT J
            NEXT K

            boardplace = (row - 1) * 3 + col
           
            GOTO endai
          END IF
        END IF
      END IF

      IF squaresused = 8 THEN 'last turn
        FOR I = 1 TO 9
          IF boardno(I) = 0 THEN boardplace = I
        NEXT I

    'First Turn
      ELSEIF squaresused = 0 THEN
       
        SELECT CASE playerai(playerturn MOD 2 + 1)
          CASE "stupid"
            boardplace = INT(9 * RND + 1)
          CASE "average"
            IF INT(10 * RND + 1) < 7 THEN
              boardplace = 5
              GOTO endai
            ELSE
              tmp = INT(4 * RND + 1)
              SELECT CASE tmp
                CASE 1
                  boardplace = 1
                CASE 2
                  boardplace = 3
                CASE 3
                  boardplace = 7
                CASE 4
                  boardplace = 9
              END SELECT
              GOTO endai
            END IF
         
          CASE "impossible"
            IF INT(10 * RND + 1) < 4 THEN
              boardplace = 5
              GOTO endai
            ELSE
              tmp = INT(4 * RND + 1)
              SELECT CASE tmp
                CASE 1
                  boardplace = 1
                CASE 2
                  boardplace = 3
                CASE 3
                  boardplace = 7
                CASE 4
                  boardplace = 9
              END SELECT
              GOTO endai
            END IF
       
        END SELECT
          
      ELSE 'If there are no combo's
       
        'Determine if computer will use ranked board positions
        tmp = 0
        IF playerai(playerturn MOD 2 + 1) = "stupid" THEN IF INT(2 * RND + 1) = 1 THEN tmp = 1
        IF playerai(playerturn MOD 2 + 1) = "average" THEN IF INT(4 * RND + 1) = 1 THEN tmp = 1
        
        IF tmp = 0 THEN
        
          tmp = INT(3 * RND)
          IF squaresused > 3 AND playerai(playerturn MOD 2 + 1) = "impossible" AND board(2, 2) = 0 THEN tmp = 0
         
          '1st preference Middle
          IF boardno(5) = 0 AND tmp <> 1 THEN
            boardplace = 5
            GOTO endai
          END IF
         
          '2nd preference diagonal  
          FOR I = 1 TO 4
            DO
              tmpnum(I) = INT(4 * RND + 1)
              tmp = 1
              FOR K = 1 TO I - 1
                IF tmpnum(I) = tmpnum(K) THEN tmp = 0
              NEXT K
            LOOP UNTIL tmp = 1
          NEXT I
         
          FOR I = 1 TO 4
            SELECT CASE tmpnum(I)
              CASE 2
                tmpnum(I) = 3
              CASE 3
                tmpnum(I) = 7
              CASE 4
                tmpnum(I) = 9
            END SELECT
          NEXT I

          FOR I = 1 TO 4
            IF boardno(tmpnum(I)) = 0 THEN
              tmp = 9 - squaresused

              IF boardno(5) = norcai AND boardno(10 - tmpnum(I)) = 5 - norcai THEN
                IF tmp = 1 THEN '0
                  boardplace = tmpnum(I)
                  GOTO endai
                END IF
              ELSE
         
                boardplace = tmpnum(I)
                GOTO endai
              END IF
            END IF
          NEXT I
          
        'last preference non-diagonal

          FOR I = 1 TO 4
            DO
              tmpnum(I) = INT(4 * RND + 1) * 2
              tmp = 1
              FOR K = 1 TO I - 1
                IF tmpnum(I) = tmpnum(K) THEN tmp = 0
              NEXT K
            LOOP UNTIL tmp = 1
          NEXT I
         

          FOR I = 1 TO 4
           
            IF boardno(tmpnum(I)) = 0 THEN
              tmp = 9 - squaresused
             
              IF boardno(5) <> 0 OR boardno(10 - tmpnum(I)) <> 0 THEN
                IF tmpnum(I) = 2 OR tmpnum(I) = 8 THEN
                 
                  IF tmpnum(I) + 1 = 0 AND tmpnum(I) - 1 = 0 THEN
                    boardplace = tmpnum(I)
                    GOTO endai
                  ELSEIF tmp = 1 THEN
                    boardplace = tmpnum(I)
                    GOTO endai
                  END IF
               
                ELSEIF tmpnum(I) = 4 OR tmpnum(I) = 6 THEN
                 
                  IF tmpnum(I) + 3 = 0 AND tmpnum(I) - 3 = 0 THEN
                    boardplace = tmpnum(I)
                    GOTO endai
                  ELSEIF tmp = 1 THEN
                    boardplace = tmpnum(I)
                    GOTO endai
                  END IF
               
                END IF
              ELSE
               
                boardplace = tmpnum(I)
                GOTO endai
              END IF
            END IF
          NEXT I
       
        'choose random peice if no strategic move avalible
          DO
            boardplace = INT(9 * RND + 1)
          LOOP UNTIL boardno(boardplace) = 0
          
        ELSE
         
        'choose a random peice
          DO
            boardplace = INT(9 * RND + 1)
          LOOP UNTIL boardno(boardplace) = 0
        END IF
      END IF
      
endai:
      
      SELECT CASE boardplace
        CASE 1 TO 3
          x = 200 + 140 * (boardplace - 1)
          y = 30
        CASE 4 TO 6
          x = 200 + 140 * (boardplace - 4)
          y = 170
        CASE 7 TO 9
          x = 200 + 140 * (boardplace - 7)
          y = 310
      END SELECT
     
      CALL eraseall
    END IF

    LINE (x + 4, y + 4)-(x + 136, y + 136), selectcol + 0, B
    IF turn = 1 THEN tmp = 1 ELSE tmp = 4
    board((boardplace + 2) MOD 3 + 1, (boardplace + 2) \ 3) = tmp
    boardno(boardplace) = tmp


    IF turn = 1 THEN
      CALL cross(boardplace + 0, playercol(playerturn MOD 2 + 1))
      turn = 2
    ELSE CALL naught(boardplace + 0, playercol(playerturn MOD 2 + 1))
      turn = 1
    END IF
    playerturn = playerturn + 1
    
'Test for a Vertical win  
    FOR J = 1 TO 3
      tmp = 0
      FOR K = 1 TO 3
        tmp = tmp + board(J, K)
      NEXT K
      IF tmp = 3 OR tmp = 12 THEN '3 is a win for crosses, 12 is a win for naughts
        IF tmp = 3 THEN endgame = 1 ELSE endgame = 2
        LINE (J * 140 + 129, 36)-(J * 140 + 134, 444), linecol, BF
      END IF
    NEXT J
   

'Test for a Horisontal win
    FOR K = 1 TO 3
      tmp = 0
      FOR J = 1 TO 3
        tmp = tmp + board(J, K)
      NEXT J
      IF tmp = 3 OR tmp = 12 THEN  '3 is a win for crosses, 12 is a win for naughts
        IF tmp = 3 THEN endgame = 1 ELSE endgame = 2
        LINE (205, K * 140 - 42)-(614, K * 140 - 37), linecol, BF
      END IF
    NEXT K

'Test for a Diagonal win
    tmp = board(1, 1) + board(2, 2) + board(3, 3) 'first diagonal
    IF tmp = 3 OR tmp = 12 THEN '3 is a win for crosses, 12 is a win for naughts
      IF tmp = 3 THEN endgame = 1 ELSE endgame = 2
          
      FOR I = 0 TO 7
        LINE (206 + I, 36)-(607 + I, 444), linecol
      NEXT I
    END IF
       
    tmp = board(3, 1) + board(2, 2) + board(1, 3) 'second diagonal
    IF tmp = 3 OR tmp = 12 THEN '3 is a win for crosses, 12 is a win for naughts
      IF tmp = 3 THEN endgame = 1 ELSE endgame = 2
     
      FOR I = 0 TO 7
        LINE (607 + I, 36)-(206 + I, 444), linecol
      NEXT I
    END IF

'Test for Draw
    tmp = 0
    FOR I = 1 TO 9
      IF boardno(I) <> 0 THEN tmp = tmp + 1
    NEXT I
    IF tmp = 9 AND endgame = 0 THEN endgame = 3 '3 means draw
 
  LOOP WHILE endgame = 0 'loop until a win or draw


'** Allocate scores
  gen = 0
  FOR I = 1 TO 9
    boardnoold(I) = boardno(I)
  NEXT I

  rounds = rounds + 1
  FOR I = 1 TO 2
    playerscore(I) = 0
  NEXT I
   
'convert endgame from 1=crosses to 1 = player1 etc
  IF playerturn MOD 2 = 1 THEN '0 player 1 is crosses, 1 player 2 is
    IF endgame = 1 OR endgame = 2 THEN
      IF endgame = 1 THEN endgame = 2 ELSE endgame = 1
    END IF
  END IF
   
  IF endgame = 1 OR endgame = 2 THEN
    playerwins(3 - (playerturn MOD 2 + 1)) = playerwins(3 - (playerturn MOD 2 + 1)) + 1
    playerlosses((playerturn MOD 2 + 1)) = playerlosses((playerturn MOD 2 + 1)) + 1
    playerscore(3 - (playerturn MOD 2 + 1)) = 1

  ELSEIF endgame = 3 THEN
    FOR I = 1 TO 2
      playerdraws(I) = playerdraws(I) + 1
    NEXT I
  END IF
  
  menuplace = 3
  LINE (0, 0)-(197, 255), 0, BF
  GOTO menu


SS:
  TIMER OFF

  DO
repeat:     
      FOR K = 1 TO 5
        ky = INKEY$
        IF ky <> "" THEN
          CLS
          GOTO menustart
        END IF
       
        colour = INT(15 * RND + 1)
        xb = INT(680 * RND - 20)
        yb = INT(520 * RND - 20)
        CALL paralagon(xb + 10, yb + 10, xb + 130, yb + 120, 10, colour + 0)
        CALL paralagon(xb + 10, yb + 120, xb + 130, yb + 10, 10, colour + 0)
       
        colour = INT(15 * RND + 1)
        FOR I = 50 TO 60
          CIRCLE (xb, yb), I, colour
          CIRCLE (xb + 1, yb), I, colour
          CIRCLE (xb, yb + 1), I, colour
          CIRCLE (xb + 1, yb + 1), I, colour
          
        NEXT I
      NEXT K
      
      ky = INKEY$

  LOOP WHILE ky = ""
  
  CLS
GOTO menustart

SUB boarddraw (colour AS INTEGER)
  LINE (200, 30)-(620, 460), 0, BF
 
  FOR y = 30 TO 320 STEP 140
    FOR x = 200 TO 480 STEP 140
   
      LINE (x, y)-(x + 140, y + 140), colour, B
      LINE (x + 2, y + 2)-(x + 138, y + 138), colour, B
      LINE (x + 3, y + 3)-(x + 137, y + 137), 0, BF
   
    NEXT x
  NEXT y

END SUB

SUB box (xi AS INTEGER, yi AS INTEGER, xf AS INTEGER, yf AS INTEGER, boxwidth AS INTEGER, boardercolour AS INTEGER, fillcolour AS INTEGER)
  LINE (xi + boxwidth, yi + boxwidth)-(xf - boxwidth, yf - boxwidth), fillcolour, BF
  LINE (xi, yi)-(xf, yi + boxwidth), boardercolour, BF
  LINE (xf, yi)-(xf - boxwidth, yf), boardercolour, BF
  LINE (xf, yf)-(xi, yf - boxwidth), boardercolour, BF
  LINE (xi, yf)-(xi + boxwidth, yi), boardercolour, BF
END SUB

'** Translates colour number to colour name
FUNCTION coltrans$ (colour AS INTEGER)
    SELECT CASE colour
      CASE 1
        coltrans$ = "blue"
      CASE 2
        coltrans$ = "green"
      CASE 3
        coltrans$ = "cyan"
      CASE 4
        coltrans$ = "red"
      CASE 5
        coltrans$ = "magenta"
      CASE 6
        coltrans$ = "brown"
      CASE 7
        coltrans$ = "white"
      CASE 8
        coltrans$ = "grey"
      CASE 9
        coltrans$ = "light blue"
      CASE 10
        coltrans$ = "light green"
      CASE 11
        coltrans$ = "light cyan"
      CASE 12
        coltrans$ = "light red"
      CASE 13
        coltrans$ = "light magenta"
      CASE 14
        coltrans$ = "yellow"
      CASE 15
        coltrans$ = "bright white"

    END SELECT

  'From Help File
  '     0 = black       4 = red           8 = grey             12 = light red
  '     1 = blue        5 = magenta       9 = light blue       13 = light magenta
  '     2 = green       6 = brown        10 = light green      14 = yellow
  '     3 = cyan        7 = white        11 = light cyan       15 = bright white

END FUNCTION

SUB cross (squareno AS INTEGER, colour AS INTEGER)
  SELECT CASE squareno
    CASE 1
      x = 200
      y = 30
    CASE 2
      x = 340
      y = 30
    CASE 3
      x = 480
      y = 30
    CASE 4
      x = 200
      y = 170
    CASE 5
      x = 340
      y = 170
    CASE 6
      x = 480
      y = 170
    CASE 7
      x = 200
      y = 310
    CASE 8
      x = 340
      y = 310
    CASE 9
      x = 480
      y = 310
  END SELECT

  CALL paralagon(x + 10, y + 10, x + 130, y + 120, 10, colour)
  CALL paralagon(x + 10, y + 120, x + 130, y + 10, 10, colour)

END SUB

SUB eraseall 'erases the board select cursor
  FOR y = 30 TO 320 STEP 140
    FOR x = 200 TO 480 STEP 140
      LINE (x + 4, y + 4)-(x + 136, y + 136), 0, B
    NEXT
  NEXT
END SUB

FUNCTION getkey$
  CONST enter = 13, escape = 27, Space = 32
  CONST Downarrow = 80, Uparrow = 72, Leftarrow = 75, Rightarrow = 77
  DIM keypress AS STRING
  DIM asckeypress AS INTEGER

  DO
    keypress = INKEY$
  LOOP WHILE keypress = ""
  asckeypress = ASC(RIGHT$(keypress, 1))

  SELECT CASE asckeypress
    CASE Space
      getkey = "space"
    CASE escape
      getkey = "escape"
    CASE Uparrow
      getkey = "up"
    CASE Downarrow
      getkey = "down"
    CASE enter
      getkey = "enter"
    CASE Rightarrow
      getkey = "right"
    CASE Leftarrow
      getkey = "left"
    CASE ELSE
      getkey = keypress
  END SELECT

END FUNCTION

SUB locatecol (row AS INTEGER, column AS INTEGER, sentence AS STRING, colour AS INTEGER)
  COLOR colour
  LOCATE row, column
  PRINT sentence
END SUB

FUNCTION nameinput$ (initplace AS INTEGER, row AS INTEGER, initname AS STRING, max AS INTEGER)
  DIM playername AS STRING
  DIM ky AS STRING
  DIM askey AS INTEGER
 
  playername = initname
  place = initplace + LEN(playername) - 1
  DO                               'asc
    CALL locatecol(row + 0, place + 1, "", 4)
    DO
      ky = INKEY$
    LOOP WHILE ky = ""
    ky = symbols$(ky)
    SELECT CASE ky
      CASE "A" TO "Z", "a" TO "z", "0" TO "9", "-", "!", "&", "*", "@", "#", "$", "|", "^", "(", ")", ",", "'", ":", ";", "<", ">", ".", "%", "?", ".", "[", "=", "+", "]", "{", "}", "\", "/", "_", "", "", "", "", "", "", "", "", "", "",  _
"", "", "", "", ""' ,asc
        IF LEN(playername) < max THEN
          place = place + 1
          CALL locatecol(row, place + 0, ky, 4)
          playername = playername + ky
        END IF
      CASE ELSE
        ascky = ASC(RIGHT$(ky, 1))
        IF ascky = enter THEN endq = 1
        IF ascky = escape THEN
                    
          nameinput = initname + "\"
          EXIT FUNCTION

        END IF

        IF ascky = Space AND LEN(playername) <= max - 1 THEN
          place = place + 1
          CALL locatecol(row, place + 0, ky, 4)
          playername = playername + ky
        END IF
        IF ascky = Backspace AND initplace - 1 <> place THEN
          playername = MID$(playername, 1, LEN(playername) - 1)
          place = place - 1
          CALL locatecol(row, place + 1, "  ", 4)
                    
        END IF

    END SELECT
    IF LTRIM$(playername) = "" THEN endq = 0
  LOOP UNTIL endq = 1 OR LEN(playername) > max
  CALL locatecol(row, place + 1, " ", 4)
  nameinput = playername

END FUNCTION

SUB naught (squareno AS INTEGER, colour AS INTEGER)
  SELECT CASE squareno
    CASE 1
      x = 270
      y = 100
    CASE 2
      x = 410
      y = 100
    CASE 3
      x = 550
      y = 100
    CASE 4
      x = 270
      y = 240
    CASE 5
      x = 410
      y = 240
    CASE 6
      x = 550
      y = 240
    CASE 7
      x = 270
      y = 380
    CASE 8
      x = 410
      y = 380
    CASE 9
      x = 550
      y = 380
  END SELECT
  CIRCLE (x, y), 50, colour
  CIRCLE (x, y), 60, colour
  PAINT (x + 52, y), colour, colour
END SUB

SUB paralagon (x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, height AS INTEGER, colour AS INTEGER)
  FOR num = 1 TO height
    LINE (x1, y1 + num)-(x2, y2 + num), colour
  NEXT
END SUB

FUNCTION symbols$ (ky AS STRING)
  'square1 = 91, square2 = 93, curv1 =123 ,curv2 = 125, plus = 43, underline = 95, equal = 61
  'const backslash = 92, forardslash = 47, verticleline = 124, semicolon = 59, quotations =34 , question = 63
  'symbols are 
  SELECT CASE ASC(ky)
    CASE square1
      symbols = ""
    CASE square2
      symbols = ""
    CASE curv1
      symbols = ""
    CASE curv2
      symbols = ""
    CASE underline
      symbols = ""
    CASE equal
      symbols = ""
    CASE backslash
      symbols = ""
    CASE forardslash
      symbols = ""
    CASE verticleline
      symbols = ""
    CASE semicolon
      symbols = ""
    CASE quotations
      symbols = ""
    CASE colon
      symbols = ""
    CASE percent
      symbols = ""
    CASE plus
      symbols = ""
    CASE ELSE
      symbols = ky
  END SELECT
END FUNCTION

